Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 10419)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 10420)
@@ -86,6 +86,6 @@
 PROGRAMS = VirtualBox
 ifeq ($(filter-out freebsd linux openbsd netbsd solaris,$(KBUILD_TARGET)),) # X11
-DLLS = VBoxKeyboard
-OTHERS = $(PATH_BIN)/vboxkeyboard.tar.gz
+DLLS = VBoxKeyboard3
+OTHERS = $(PATH_BIN)/vboxkeyboard3.tar.gz
 endif
 INSTALLS = VirtualBox.nls
@@ -119,9 +119,9 @@
 # VBoxKeyboard - keyboard library for X11.
 #
-VBoxKeyboard_TEMPLATE = VBOXR3
-VBoxKeyboard_SOURCES  = \
+VBoxKeyboard3_TEMPLATE = VBOXR3
+VBoxKeyboard3_SOURCES  = \
 	src/linux/keyboard-new.c
-VBoxKeyboard_TARSOURCES = \
-	$(VBoxKeyboard_SOURCES) \
+VBoxKeyboard3_TARSOURCES = \
+	$(VBoxKeyboard3_SOURCES) \
 	src/linux/COPYING.LIB \
 	src/linux/keyboard.h \
@@ -131,13 +131,13 @@
 	src/linux/keyboard-types.h \
 	src/linux/Makefile
-VBoxKeyboard_LIBS     = X11
-VBoxKeyboard_LIBPATH  = $(VBOX_LIBPATH_X11)
-
-
-#
-# vboxkeyboard.tar.gz - the LGPLed keyboard library must always be
+VBoxKeyboard3_LIBS     = X11
+VBoxKeyboard3_LIBPATH  = $(VBOX_LIBPATH_X11)
+
+
+#
+# vboxkeyboard3.tar.gz - the LGPLed keyboard library must always be
 # redistributed with usable sources.
 #
-SOURCE_DIRECTORY = vboxkeyboard
+SOURCE_DIRECTORY = vboxkeyboard3
 DIRECTORY_PREFIX = src/linux/
 
@@ -146,7 +146,7 @@
 	$(LN_SYMLINK) $(abspath $(PATH_CURRENT))/$(DIRECTORY_PREFIX) $@
 
-$(PATH_BIN)/vboxkeyboard.tar.gz: $(VBoxKeyboard_TARSOURCES) $(PATH_TARGET)/$(SOURCE_DIRECTORY)
+$(PATH_BIN)/vboxkeyboard3.tar.gz: $(VBoxKeyboard3_TARSOURCES) $(PATH_TARGET)/$(SOURCE_DIRECTORY)
 	$(call MSG_TOOL,tar/gzip,,$@)
-	$(QUIET)cd $(PATH_TARGET) && tar -chf - $(addprefix $(SOURCE_DIRECTORY)/,$(subst $(DIRECTORY_PREFIX),,$(VBoxKeyboard_TARSOURCES))) | gzip - > $@
+	$(QUIET)cd $(PATH_TARGET) && tar -chf - $(addprefix $(SOURCE_DIRECTORY)/,$(subst $(DIRECTORY_PREFIX),,$(VBoxKeyboard3_TARSOURCES))) | gzip - > $@
 
 
@@ -155,4 +155,5 @@
 #
 VirtualBox_TEMPLATE = VBOXQTGUIEXE
+VirtualBox_NAME     = VirtualBox3
 VirtualBox_SDKS.win = WINPSDK DXSDK
 #ifeq ($(filter-out freebsd linux netbsd openbsd os2 solaris,$(KBUILD_TARGET)),) - later
@@ -163,5 +164,5 @@
 ifeq ($(KBUILD_TARGET),darwin)
 # For the launch trick we need different inode numbers.
-VirtualBox_INST = $(INST_BIN)VirtualBox $(INST_BIN)VirtualBoxVM
+VirtualBox_INST = $(INST_BIN)VirtualBox3 $(INST_BIN)VirtualBoxVM3
 
  # For testing iChat Theater stuff change
@@ -392,5 +393,5 @@
 VirtualBox_LIBS.os2      += $(PATH_DLL)/VBoxHlp$(VBOX_SUFF_DLL)
 ifeq ($(filter-out freebsd linux netbsd openbsd solaris,$(KBUILD_TARGET)),) # X11
-VirtualBox_LIBS          += $(PATH_DLL)/VBoxKeyboard$(VBOX_SUFF_DLL)
+VirtualBox_LIBS          += $(PATH_DLL)/VBoxKeyboard3$(VBOX_SUFF_DLL)
 endif
 
@@ -417,5 +418,5 @@
 	$(VirtualBox_GENHDRS) \
 	$(WRAPPERSFILE) \
-	$(PATH_BIN)/vboxkeyboard.tar.gz
+	$(PATH_BIN)/vboxkeyboard3.tar.gz
 
 
@@ -476,5 +477,5 @@
 # Translation installation
 #
-VirtualBox.nls_INST = $(INST_BIN)nls/
+VirtualBox.nls_INST = $(INST_BIN)nls3/
 VirtualBox.nls_SOURCES =  $(patsubst %.ts,$(PATH_VirtualBox)/nls/%.qm,$(notdir $(VirtualBox_QT_TRANSLATIONS)))
 VirtualBox.nls_SOURCES += $(patsubst %.ts,$(PATH_VirtualBox)/nls/%.qm,$(notdir $(VirtualBox_QT_TRANSLATIONS_QT)))
@@ -488,4 +489,5 @@
 PROGRAMS.darwin += tstDarwinKeyboard
 tstDarwinKeyboard_TEMPLATE = VBOXR3TSTEXE
+tstDarwinKeyboard_NAME = tstDarwinKeyboard3
 tstDarwinKeyboard_INCS = include
 tstDarwinKeyboard_SOURCES = \
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 10419)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 10420)
@@ -2627,5 +2627,5 @@
 }
 
-extern const char *gVBoxLangSubDir = "/nls";
+extern const char *gVBoxLangSubDir = "/nls3";
 extern const char *gVBoxLangFileBase = "VirtualBox_";
 extern const char *gVBoxLangFileExt = ".qm";
Index: /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 10419)
+++ /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 10420)
@@ -349,8 +349,8 @@
 PROGRAMS += VirtualBox4
 ifeq ($(filter-out freebsd linux openbsd netbsd solaris,$(KBUILD_TARGET)),) # X11
- DLLS += VBoxKeyboard4
+ DLLS += VBoxKeyboard
  ## @todo convert to install target.
- OTHERS += $(PATH_BIN)/vboxkeyboard4.tar.gz
- CLEAN += $(PATH_BIN)/vboxkeyboard4.tar.gz
+ OTHERS += $(PATH_BIN)/vboxkeyboard.tar.gz
+ CLEAN += $(PATH_BIN)/vboxkeyboard.tar.gz
 endif
 INSTALLS += VirtualBox4.nls qt4-bin
@@ -360,9 +360,9 @@
 # VBoxKeyboard - keyboard library for X11.
 #
-VBoxKeyboard4_TEMPLATE = VBOXR3
-VBoxKeyboard4_SOURCES  = \
+VBoxKeyboard_TEMPLATE = VBOXR3
+VBoxKeyboard_SOURCES  = \
 	src/linux/keyboard-new.c
-VBoxKeyboard4_LIBS     = X11
-VBoxKeyboard4_LIBPATH  = $(VBOX_LIBPATH_X11)
+VBoxKeyboard_LIBS     = X11
+VBoxKeyboard_LIBPATH  = $(VBOX_LIBPATH_X11)
 
 
@@ -377,6 +377,6 @@
 #
 ## @todo this should be tar'ed down into the output directory and installed using an install target.
-$(PATH_BIN)/vboxkeyboard4.tar.gz: \
-		$(VBoxKeyboard4_SOURCES) \
+$(PATH_BIN)/vboxkeyboard.tar.gz: \
+		$(VBoxKeyboard_SOURCES) \
 		src/linux/COPYING.LIB \
 		src/linux/keyboard.h \
@@ -387,10 +387,10 @@
 		src/linux/Makefile
 	$(call MSG_TOOL,tar/gzip,,$@)
-	$(QUIET2)$(RM) -f $(PATH_TARGET)/vboxkeyboard4 $@
-	$(QUIET)$(LN_SYMLINK) $(VBOX_VIRTUALBOX4_SRC)/src/linux/ $(PATH_TARGET)/vboxkeyboard4
+	$(QUIET2)$(RM) -f $(PATH_TARGET)/vboxkeyboard $@
+	$(QUIET)$(LN_SYMLINK) $(VBOX_VIRTUALBOX4_SRC)/src/linux/ $(PATH_TARGET)/vboxkeyboard
 	$(QUIET)cd $(PATH_TARGET) \
-		&& tar -chvf - $(addprefix vboxkeyboard4/,$(notdir $^)) \
+		&& tar -chvf - $(addprefix vboxkeyboard/,$(notdir $^)) \
 		   | gzip - > $@
-	$(QUIET2)$(RM) -f $(PATH_TARGET)/vboxkeyboard4
+	$(QUIET2)$(RM) -f $(PATH_TARGET)/vboxkeyboard
 
 
@@ -407,4 +407,5 @@
 #
 VirtualBox4_TEMPLATE = VBOXQT4GUIEXE
+VirtualBox4_NAME = VirtualBox
 VirtualBox4_SDKS.win = WINPSDK DXSDK
 ifeq ($(filter-out freebsd linux netbsd openbsd os2,$(KBUILD_TARGET)),) # X11 + os2 ## @todo solaris
@@ -414,5 +415,5 @@
 ifeq ($(KBUILD_TARGET),darwin)
  # For the launch trick we need different inode numbers.
- VirtualBox4_INST = $(INST_BIN)VirtualBox4 $(INST_BIN)VirtualBoxVM4
+ VirtualBox4_INST = $(INST_BIN)VirtualBox $(INST_BIN)VirtualBoxVM
 
  # For testing iChat Theater stuff change the sdk path (HACK ALERT!)
@@ -495,5 +496,5 @@
 	$(PATH_SDK_DXSDK_LIB)/dxguid.lib
 ifeq ($(filter-out freebsd linux netbsd openbsd solaris,$(KBUILD_TARGET)),) # X11
- VirtualBox4_LIBS         += $(PATH_DLL)/VBoxKeyboard4$(VBOX_SUFF_DLL)
+ VirtualBox4_LIBS         += $(PATH_DLL)/VBoxKeyboard$(VBOX_SUFF_DLL)
 endif
 
@@ -839,5 +840,5 @@
 #
 ifndef USE_KBUILD_QT_UNIT ## @todo later
-VirtualBox4.nls_INST = $(INST_BIN)nls4/
+VirtualBox4.nls_INST = $(INST_BIN)nls/
 VirtualBox4.nls_SOURCES =  $(patsubst %.ts,$(PATH_VirtualBox4)/nls/%.qm,$(notdir $(VirtualBox4_QT_TRANSLATIONS)))
 VirtualBox4.nls_SOURCES += $(patsubst %.ts,$(PATH_VirtualBox4)/nls/%.qm,$(notdir $(VirtualBox4_QT_TRANSLATIONS_QT)))
@@ -851,4 +852,5 @@
 ifdef VBOX_WITH_TESTCASES
 PROGRAMS.darwin += tstDarwinKeyboard4
+tstDarwinKeyboard4_NAME = tstDarwinKeyboard
 tstDarwinKeyboard4_TEMPLATE = VBOXR3TSTEXE
 tstDarwinKeyboard4_INCS = include
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 10419)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 10420)
@@ -2538,5 +2538,5 @@
 }
 
-extern const char *gVBoxLangSubDir = "/nls4";
+extern const char *gVBoxLangSubDir = "/nls";
 extern const char *gVBoxLangFileBase = "VirtualBox_";
 extern const char *gVBoxLangFileExt = ".qm";
Index: /trunk/src/VBox/Main/MachineImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/MachineImpl.cpp	(revision 10419)
+++ /trunk/src/VBox/Main/MachineImpl.cpp	(revision 10420)
@@ -3424,7 +3424,7 @@
     {
 #ifdef RT_OS_DARWIN /* Avoid Lanuch Services confusing this with the selector by using a helper app. */
-        const char VirtualBox_exe[] = "../Resources/VirtualBoxVM.app/Contents/MacOS/VirtualBoxVM";
+        const char VirtualBox_exe[] = "../Resources/VirtualBoxVM.app/Contents/MacOS/VirtualBoxVM3";
 #else
-        const char VirtualBox_exe[] = "VirtualBox" HOSTSUFF_EXE;
+        const char VirtualBox_exe[] = "VirtualBox3" HOSTSUFF_EXE;
 #endif
         Assert (sz >= sizeof (VirtualBox_exe));
@@ -3444,7 +3444,7 @@
     {
 #ifdef RT_OS_DARWIN /* Avoid Lanuch Services confusing this with the selector by using a helper app. */
-        const char VirtualBox_exe[] = "../Resources/VirtualBoxVM.app/Contents/MacOS/VirtualBoxVM4";
+        const char VirtualBox_exe[] = "../Resources/VirtualBoxVM.app/Contents/MacOS/VirtualBoxVM";
 #else
-        const char VirtualBox_exe[] = "VirtualBox4" HOSTSUFF_EXE;
+        const char VirtualBox_exe[] = "VirtualBox" HOSTSUFF_EXE;
 #endif
         Assert (sz >= sizeof (VirtualBox_exe));