Index: trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 10485)
+++ trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 10524)
@@ -171,5 +171,5 @@
  * @param   hIF         The interface handle to validate and translate.
  */
-DECLINLINE(PINTNETIF) INTNETHandle2IFPtr(PINTNET pIntNet, INTNETIFHANDLE hIF)
+DECLINLINE(PINTNETIF) intnetHandle2IFPtr(PINTNET pIntNet, INTNETIFHANDLE hIF)
 {
     Assert(pIntNet);
@@ -202,5 +202,5 @@
  * @param   pIF         The interface which we're allocating a handle for.
  */
-static INTNETIFHANDLE INTNETHandleAllocate(PINTNET pIntNet, PINTNETIF pIF)
+static INTNETIFHANDLE intnetHandleAllocate(PINTNET pIntNet, PINTNETIF pIF)
 {
     Assert(pIF);
@@ -287,7 +287,7 @@
  * @param   h           The handle we're freeing.
  */
-static void INTNETHandleFree(PINTNET pIntNet, INTNETIFHANDLE h)
-{
-    Assert(INTNETHandle2IFPtr(pIntNet, h));
+static void intnetHandleFree(PINTNET pIntNet, INTNETIFHANDLE h)
+{
+    Assert(intnetHandle2IFPtr(pIntNet, h));
     PINTNETHT       pHT = &pIntNet->IfHandles;
     const uint32_t  i   = h & INTNET_HANDLE_INDEX_MASK;
@@ -327,5 +327,5 @@
  *                      ensuring that there is sufficient space for the frame.
  */
-static unsigned INTNETRingReadFrame(PINTNETBUF pBuf, PINTNETRINGBUF pRingBuf, void *pvFrame)
+static unsigned intnetRingReadFrame(PINTNETBUF pBuf, PINTNETRINGBUF pRingBuf, void *pvFrame)
 {
     Assert(pRingBuf->offRead < pBuf->cbBuf);
@@ -359,5 +359,5 @@
  * @param   cbFrame     The size of the frame.
  */
-static int INTNETRingWriteFrame(PINTNETBUF pBuf, PINTNETRINGBUF pRingBuf, const void *pvFrame, uint32_t cbFrame)
+static int intnetRingWriteFrame(PINTNETBUF pBuf, PINTNETRINGBUF pRingBuf, const void *pvFrame, uint32_t cbFrame)
 {
     /*
@@ -465,5 +465,5 @@
 {
     LogFlow(("intnetIfSend: pIf=%p:{.hIf=%RX32}\n", pIf, pIf->hIf));
-    int rc = INTNETRingWriteFrame(pIf->pIntBuf, &pIf->pIntBuf->Recv, pvFrame, cbFrame);
+    int rc = intnetRingWriteFrame(pIf->pIntBuf, &pIf->pIntBuf->Recv, pvFrame, cbFrame);
     if (VBOX_SUCCESS(rc))
     {
@@ -486,5 +486,5 @@
             RTSemEventSignal(pIf->Event);
             RTThreadYield();
-            rc = INTNETRingWriteFrame(pIf->pIntBuf, &pIf->pIntBuf->Recv, pvFrame, cbFrame);
+            rc = intnetRingWriteFrame(pIf->pIntBuf, &pIf->pIntBuf->Recv, pvFrame, cbFrame);
             if (VBOX_SUCCESS(rc))
             {
@@ -607,5 +607,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
         return VERR_INVALID_HANDLE;
@@ -684,5 +684,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
         return VERR_INVALID_HANDLE;
@@ -737,5 +737,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
         return VERR_INVALID_HANDLE;
@@ -773,5 +773,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
         return VERR_INVALID_HANDLE;
@@ -813,5 +813,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
     {
@@ -862,5 +862,5 @@
      */
     AssertReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
     {
@@ -934,5 +934,5 @@
      */
     AssertPtrReturn(pIntNet, VERR_INVALID_PARAMETER);
-    PINTNETIF pIf = INTNETHandle2IFPtr(pIntNet, hIf);
+    PINTNETIF pIf = intnetHandle2IFPtr(pIntNet, hIf);
     if (!pIf)
         return VERR_INVALID_HANDLE;
@@ -967,7 +967,7 @@
  * @param   pvUser2     Pointer to the INTNET instance data.
  */
-static DECLCALLBACK(void) INTNETIfDestruct(void *pvObj, void *pvUser1, void *pvUser2)
-{
-    LogFlow(("INTNETIfDestruct: pvObj=%p pvUser1=%p pvUser2=%p\n", pvObj, pvUser1, pvUser2));
+static DECLCALLBACK(void) intnetIfDestruct(void *pvObj, void *pvUser1, void *pvUser2)
+{
+    LogFlow(("intnetIfDestruct: pvObj=%p pvUser1=%p pvUser2=%p\n", pvObj, pvUser1, pvUser2));
     PINTNETIF pIf = (PINTNETIF)pvUser1;
     PINTNET   pIntNet = (PINTNET)pvUser2;
@@ -978,5 +978,5 @@
     if (pIf->hIf != INTNET_HANDLE_INVALID)
     {
-        INTNETHandleFree(pIntNet, pIf->hIf);
+        intnetHandleFree(pIntNet, pIf->hIf);
         ASMAtomicXchgSize(&pIf->hIf, INTNET_HANDLE_INVALID);
     }
@@ -1086,7 +1086,7 @@
  * @param   phIf        Where to store the interface handle.
  */
-static int INTNETNetworkCreateIf(PINTNETNETWORK pNetwork, PSUPDRVSESSION pSession, unsigned cbSend, unsigned cbRecv, PINTNETIFHANDLE phIf)
-{
-    LogFlow(("INTNETNetworkCreateIf: pNetwork=%p pSession=%p cbSend=%u cbRecv=%u phIf=%p\n",
+static int intnetNetworkCreateIf(PINTNETNETWORK pNetwork, PSUPDRVSESSION pSession, unsigned cbSend, unsigned cbRecv, PINTNETIFHANDLE phIf)
+{
+    LogFlow(("intnetNetworkCreateIf: pNetwork=%p pSession=%p cbSend=%u cbRecv=%u phIf=%p\n",
              pNetwork, pSession, cbSend, cbRecv, phIf));
 
@@ -1150,12 +1150,12 @@
                  * Register the interface with the session.
                  */
-                pIf->pvObj = SUPR0ObjRegister(pSession, SUPDRVOBJTYPE_INTERNAL_NETWORK_INTERFACE, INTNETIfDestruct, pIf, pNetwork->pIntNet);
+                pIf->pvObj = SUPR0ObjRegister(pSession, SUPDRVOBJTYPE_INTERNAL_NETWORK_INTERFACE, intnetIfDestruct, pIf, pNetwork->pIntNet);
                 if (pIf->pvObj)
                 {
-                    pIf->hIf = INTNETHandleAllocate(pNetwork->pIntNet, pIf);
+                    pIf->hIf = intnetHandleAllocate(pNetwork->pIntNet, pIf);
                     if (pIf->hIf != INTNET_HANDLE_INVALID)
                     {
                         *phIf = pIf->hIf;
-                        LogFlow(("INTNETNetworkCreateIf: returns VINF_SUCCESS *phIf=%p\n", *phIf));
+                        LogFlow(("intnetNetworkCreateIf: returns VINF_SUCCESS *phIf=%p\n", *phIf));
                         return VINF_SUCCESS;
                     }
@@ -1163,5 +1163,5 @@
 
                     SUPR0ObjRelease(pIf->pvObj, pSession);
-                    LogFlow(("INTNETNetworkCreateIf: returns %Vrc\n", rc));
+                    LogFlow(("intnetNetworkCreateIf: returns %Vrc\n", rc));
                     return rc;
                 }
@@ -1179,5 +1179,5 @@
     }
     RTMemFree(pIf);
-    LogFlow(("INTNETNetworkCreateIf: returns %Vrc\n", rc));
+    LogFlow(("intnetNetworkCreateIf: returns %Vrc\n", rc));
     return rc;
 }
@@ -1185,12 +1185,12 @@
 
 /**
- * Close a network which was opened/created using INTNETOpenNetwork()/INTNETCreateNetwork().
+ * Close a network which was opened/created using intnetOpenNetwork()/intnetCreateNetwork().
  *
  * @param   pNetwork    The network to close.
  * @param   pSession    The session handle.
  */
-static int INTNETNetworkClose(PINTNETNETWORK pNetwork, PSUPDRVSESSION pSession)
-{
-    LogFlow(("INTNETNetworkClose: pNetwork=%p pSession=%p\n", pNetwork, pSession));
+static int intnetNetworkClose(PINTNETNETWORK pNetwork, PSUPDRVSESSION pSession)
+{
+    LogFlow(("intnetNetworkClose: pNetwork=%p pSession=%p\n", pNetwork, pSession));
     AssertPtrReturn(pSession, VERR_INVALID_PARAMETER);
     AssertPtrReturn(pNetwork, VERR_INVALID_PARAMETER);
@@ -1201,5 +1201,5 @@
     int rc = SUPR0ObjRelease(pNetwork->pvObj, pSession);
     RTSpinlockRelease(pIntNet->Spinlock, &Tmp);
-    LogFlow(("INTNETNetworkClose: return %Vrc\n", rc));
+    LogFlow(("intnetNetworkClose: return %Vrc\n", rc));
     return rc;
 }
@@ -1214,7 +1214,7 @@
  * @param   pvUser2     Pointer to the INTNET instance data.
  */
-static DECLCALLBACK(void) INTNETNetworkDestruct(void *pvObj, void *pvUser1, void *pvUser2)
-{
-    LogFlow(("INTNETNetworkDestruct: pvObj=%p pvUser1=%p pvUser2=%p\n", pvObj, pvUser1, pvUser2));
+static DECLCALLBACK(void) intnetNetworkDestruct(void *pvObj, void *pvUser1, void *pvUser2)
+{
+    LogFlow(("intnetNetworkDestruct: pvObj=%p pvUser1=%p pvUser2=%p\n", pvObj, pvUser1, pvUser2));
     RTSPINLOCKTMP   Tmp = RTSPINLOCKTMP_INITIALIZER;
     PINTNETNETWORK  pNetwork = (PINTNETNETWORK)pvUser1;
@@ -1277,7 +1277,7 @@
  * @param   ppNetwork   Where to store the pointer to the network on success.
  */
-static int INTNETOpenNetwork(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, PINTNETNETWORK *ppNetwork)
-{
-    LogFlow(("INTNETOpenNetwork: pIntNet=%p pSession=%p pszNetwork=%p:{%s} ppNetwork=%p\n",
+static int intnetOpenNetwork(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, PINTNETNETWORK *ppNetwork)
+{
+    LogFlow(("intnetOpenNetwork: pIntNet=%p pSession=%p pszNetwork=%p:{%s} ppNetwork=%p\n",
              pIntNet, pSession, pszNetwork, pszNetwork, ppNetwork));
 
@@ -1323,5 +1323,5 @@
                 }
             }
-            LogFlow(("INTNETOpenNetwork: returns %Vrc *ppNetwork=%p\n", rc, *ppNetwork));
+            LogFlow(("intnetOpenNetwork: returns %Vrc *ppNetwork=%p\n", rc, *ppNetwork));
             return rc;
         }
@@ -1330,5 +1330,5 @@
     RTSpinlockRelease(pIntNet->Spinlock, &Tmp);
 
-    LogFlow(("INTNETOpenNetwork: returns VERR_FILE_NOT_FOUND\n"));
+    LogFlow(("intnetOpenNetwork: returns VERR_FILE_NOT_FOUND\n"));
     return VERR_FILE_NOT_FOUND;
 }
@@ -1349,7 +1349,7 @@
  * @param   ppNetwork       Where to store the network.
  */
-static int INTNETCreateNetwork(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, bool fRestrictAccess, PINTNETNETWORK *ppNetwork)
-{
-    LogFlow(("INTNETCreateNetwork: pIntNet=%p pSession=%p pszNetwork=%p:{%s} ppNetwork=%p\n",
+static int intnetCreateNetwork(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, bool fRestrictAccess, PINTNETNETWORK *ppNetwork)
+{
+    LogFlow(("intnetCreateNetwork: pIntNet=%p pSession=%p pszNetwork=%p:{%s} ppNetwork=%p\n",
              pIntNet, pSession, pszNetwork, pszNetwork, ppNetwork));
 
@@ -1371,5 +1371,5 @@
         {
             RTSpinlockRelease(pIntNet->Spinlock, &Tmp);
-            LogFlow(("INTNETCreateNetwork: returns VERR_ALREADY_EXISTS\n"));
+            LogFlow(("intnetCreateNetwork: returns VERR_ALREADY_EXISTS\n"));
             return VERR_ALREADY_EXISTS;
         }
@@ -1395,5 +1395,5 @@
          * Register the object in the current session.
          */
-        pNew->pvObj = SUPR0ObjRegister(pSession, SUPDRVOBJTYPE_INTERNAL_NETWORK, INTNETNetworkDestruct, pNew, pIntNet);
+        pNew->pvObj = SUPR0ObjRegister(pSession, SUPDRVOBJTYPE_INTERNAL_NETWORK, intnetNetworkDestruct, pNew, pIntNet);
         if (pNew->pvObj)
         {
@@ -1416,5 +1416,5 @@
             {
                 *ppNetwork = pNew;
-                LogFlow(("INTNETCreateNetwork: returns VINF_SUCCESS *ppNetwork=%p\n", pNew));
+                LogFlow(("intnetCreateNetwork: returns VINF_SUCCESS *ppNetwork=%p\n", pNew));
                 return VINF_SUCCESS;
             }
@@ -1422,5 +1422,5 @@
             /* The release will destroy the object. */
             SUPR0ObjRelease(pNew->pvObj, pSession);
-            LogFlow(("INTNETCreateNetwork: returns %Vrc\n", rc));
+            LogFlow(("intnetCreateNetwork: returns %Vrc\n", rc));
             return rc;
         }
@@ -1431,5 +1431,5 @@
     }
     RTMemFree(pNew);
-    LogFlow(("INTNETCreateNetwork: returns %Vrc\n", rc));
+    LogFlow(("intnetCreateNetwork: returns %Vrc\n", rc));
     return rc;
 }
@@ -1508,7 +1508,7 @@
      */
     PINTNETNETWORK pNetwork;
-    rc = INTNETOpenNetwork(pIntNet, pSession, pszNetwork, &pNetwork);
+    rc = intnetOpenNetwork(pIntNet, pSession, pszNetwork, &pNetwork);
     if (rc == VERR_FILE_NOT_FOUND)
-        rc = INTNETCreateNetwork(pIntNet, pSession, pszNetwork, !(fFlags & INTNET_OPEN_FLAGS_PUBLIC), &pNetwork);
+        rc = intnetCreateNetwork(pIntNet, pSession, pszNetwork, !(fFlags & INTNET_OPEN_FLAGS_PUBLIC), &pNetwork);
     if (VBOX_SUCCESS(rc))
     {
@@ -1518,7 +1518,7 @@
          * interface is destroyed or the last session is doing cleanup (order problems).
          */
-        rc = INTNETNetworkCreateIf(pNetwork, pSession, cbSend, cbRecv, phIf);
+        rc = intnetNetworkCreateIf(pNetwork, pSession, cbSend, cbRecv, phIf);
         if (VBOX_FAILURE(rc))
-            INTNETNetworkClose(pNetwork, pSession);
+            intnetNetworkClose(pNetwork, pSession);
     }
 
Index: trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp	(revision 10485)
+++ trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp	(revision 10524)
@@ -236,5 +236,5 @@
         int rc = INTNETR0IfSend(pArgs->pIntNet, pArgs->hIf, abBuf, cb);
 #else
-        int rc = INTNETRingWriteFrame(pArgs->pBuf, &pArgs->pBuf->Send, abBuf, cb);
+        int rc = intnetRingWriteFrame(pArgs->pBuf, &pArgs->pBuf->Send, abBuf, cb);
         if (RT_SUCCESS(rc))
             rc = INTNETR0IfSend(pArgs->pIntNet, pArgs->hIf, NULL, 0);
@@ -313,5 +313,5 @@
         {
             uint8_t abBuf[16384];
-            unsigned cb = INTNETRingReadFrame(pArgs->pBuf, &pArgs->pBuf->Recv, abBuf);
+            unsigned cb = intnetRingReadFrame(pArgs->pBuf, &pArgs->pBuf->Recv, abBuf);
             unsigned *puFrame = (unsigned *)&abBuf[sizeof(PDMMAC) * 2];
 
@@ -459,5 +459,5 @@
                                 g_cErrors++;
                             }
-                            unsigned cb = INTNETRingReadFrame(pBuf1, &pBuf1->Recv, abBuf);
+                            unsigned cb = intnetRingReadFrame(pBuf1, &pBuf1->Recv, abBuf);
                             if (cb != sizeof(g_TestFrame0))
                             {